django/my_try/my_project/allauth/socialaccount/urls.py
from django.urls import path

from . import views


urlpatterns = [
    path(
        "login/cancelled/",
        views.login_cancelled,
        name="socialaccount_login_cancelled",
    ),
    path("login/error/", views.login_error, name="socialaccount_login_error"),
    path("signup/", views.signup, name="socialaccount_signup"),
    path("connections/", views.connections, name="socialaccount_connections"),
]

django/my_try/my_project/allauth/urls.py
from importlib import import_module

from django.urls import include, path

from allauth.socialaccount import providers

from . import app_settings


urlpatterns = [path("", include("allauth.account.urls"))]

if app_settings.SOCIALACCOUNT_ENABLED:
    urlpatterns += [path("social/", include("allauth.socialaccount.urls"))]

# Provider urlpatterns, as separate attribute (for reusability).
provider_urlpatterns = []
for provider in providers.registry.get_list():
    try:
        prov_mod = import_module(provider.get_package() + ".urls")
    except ImportError:
        continue
    prov_urlpatterns = getattr(prov_mod, "urlpatterns", None)
    if prov_urlpatterns:
        provider_urlpatterns += prov_urlpatterns
urlpatterns += provider_urlpatterns

django/my_try/my_project/my_app/urls.py
from django.contrib import admin
from django.urls import path
from my_app import views
app_name = 'my_app'
urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
    path('parents/', views.ParentList.as_view(), name='parent_list'),
    path('parent_create/', views.ParentCreate.as_view(), name='parent_create'),
    path('parents/<str:pk>/', views.ParentDetail.as_view(), name='parent_detail'),
    path('delete/<str:pk>', views.ParentDelete.as_view(), name="parent_delete"),
    path('register/', views.register_request, name="register"),
    path('login/', views.login_request, name="login"),
    path('logout/', views.logout_request, name="logout"),
    path('my_req/', views.my_req, name='my_req'),
    path('error_req/', views.error_req, name='error_req'),
]

django/my_try/my_project/my_project/urls.py
from django.contrib import admin
from django.urls import path
from django.urls.conf import include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('app/', include('my_app.urls', namespace='my_app')),
]

django/my_try/my_project/my_app/models.py
from django.db import models
from django.db.models.fields import CharField, EmailField
from django.db.models.fields.related import ForeignKey
from django.urls import reverse

class Parent(models.Model):
    first_name = CharField(max_length=100)
    last_name = CharField(max_length=100)
    nationality = CharField(max_length=100)
    def __str__(self) -> str:
        return self.first_name +' '+ self.last_name
    def get_absolute_url(self):
        return reverse("my_app:parent_detail", kwargs={"pk": self.pk})
    

class Child(models.Model):
    first_name = CharField(max_length=100)
    last_name = ForeignKey(Parent, on_delete=models.CASCADE)
    email = EmailField(max_length=500)
    def __str__(self) -> str:
        return self.first_name +' '+ self.last_name

django/my_try/my_project/my_app/forms.py
from django.forms import ModelForm
from django import forms
from my_app.models import Parent,Child
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User


class ParentForm(ModelForm):
    class Meta:
        model = Parent
        fields = ['first_name', 'last_name', 'nationality']

class ChildForm(ModelForm):
    class Meta:
        model = Child
        fields = ['first_name', 'last_name', 'email']


class NewUserForm(UserCreationForm):
    email = forms.EmailField(required=True)
    class Meta():
        model = User
        fields = ['username', 'email']
    def save(self, commit = False):
        user = super(NewUserForm, self).save(commit=False)
        user.email = self.cleaned_data['email']
        if commit:
            user.save()
        return user

django/my_try/my_project/my_app/views.py
from django.views.generic import (
    TemplateView, DetailView, ListView, CreateView, DeleteView
)
from django.shortcuts import get_object_or_404
from my_app.models import Parent,Child
from my_app.forms import  NewUserForm, ParentForm, ChildForm
from django.views.generic.edit import FormView
from django.urls import reverse_lazy
from django.contrib.auth import login,authenticate,logout
from django.contrib import messages
from django.shortcuts import render, redirect
from django.contrib.auth.forms import AuthenticationForm #add this
from django.contrib.auth.mixins import LoginRequiredMixin
from django.core.mail import send_mail

import logging

logger = logging.getLogger('my_app.views')

class IndexView(TemplateView):
    template_name = 'index.html'    

class ParentList(ListView):
    template_name = 'parent_list.html'
    context_object_name = 'parent_list'
    def get_queryset(self):
        return Parent.objects.all()


class ParentDetail(DetailView):
    template_name = 'parent_detail.html'
    context_object_name = 'parent_detail'
    model = Parent



class ParentCreate(LoginRequiredMixin, CreateView):
    login_url = 'my_app:login'
    redirect_field_name = 'parent_list'
    template_name = 'parent_create.html'
    model = Parent
    fields = ['first_name', 'last_name', 'nationality']

class ParentDelete(DeleteView):
    template_name = 'delete.html'
    model = Parent
    success_url = reverse_lazy('my_app:parent_list')

def register_request(request):
    print(1)
    if request.method == 'POST':
        print(2)
        form = NewUserForm(request.POST)
        if form.is_valid():
            print(3)
            user = form.save(True)
            login(request, user)
            messages.success(request, "Registration Successful.")
            return redirect("my_app:index")
        else:
            print(4)
            messages.error(request, "Unsuccessfull registering. Invalid information!")
    print(5)
    form = NewUserForm()
    return render(request=request, template_name="register.html", context={"register_form": form})

def login_request(request):
    logger.error(0)
    if request.method == 'POST':
        logger.error(1)
        form = AuthenticationForm(request, data=request.POST)
        if form.is_valid():
            logger.error(2)
            username = form.cleaned_data['username']
            password = form.cleaned_data['password']
            user = authenticate(username = username,password = password)
            if user != None:
                logger.error(3)
                login(request, user)
                messages.info(request, f'Successfully logged in {username}')
                return redirect('my_app:index')
            else:
               logger.error(4)
               messages.error(request, "Unsuccessfull logging. Invalid information!")
        else:
            logger.error(1)
            messages.error(request, "Invalid username or password")
    logger.error(6)
    form = AuthenticationForm()
    return render(request=request, template_name="login.html", context={'form':form})

def logout_request(request):
    logout(request)
    messages.add_message(request, messages.INFO, '{0} logged out.'.format(request.user))
    messages.info(request, "Succesfully logged out.")
    return redirect('my_app:index')


def my_req(request):
    logger.info('Succesfull ')
    form = Parent.objects.raw('SELECT * FROM qvendor1_1.Exchanges limit 10000;')
    messages.success(request, 'Select ran successful1')
    messages.info(request, 'Select ran successful2')
    messages.error(request, 'Select ran successful3')
    messages.error(request, 'Select did not run successful4')
    # send_mail('This is the first mail', 'It s very important for you to see this', 'protiuc20@gmail.com', 
    #   ['ovidiu.protiuc00@e-uvt.ro', 'protiuc.ovidiu@yahoo.com'], fail_silently=False)
    return render(request=request, template_name="my_req.html", context={'form':form})

def error_req(request):
    print('aici')
    logger.error('Something went wrong!')
    print(__name__)
    return render(request=request, template_name="index.html")

# Create your views here.

django/my_try/my_project/my_app/templates/my_app/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <!-- <meta http-equiv="X-UA-Compatible" content="IE=edge"> -->
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Family</title>
    <!-- CSS only -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <!-- JavaScript Bundle with Popper -->
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.0/dist/js/bootstrap.bundle.min.js" integrity="sha384-U1DAWAznBHeqEIlVSCgzq+c9gqGAJn5c/t99JyeKa9xxaYpSvHU5awsuZVVFIhvj" crossorigin="anonymous"></script>
</head>
<body>
    <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <div class="container-fluid">
          <a class="navbar-brand" href="{%url 'my_app:index'%}">Navbar</a>
          <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
          </button>
          <div class="collapse navbar-collapse" id="navbarNav">
            <ul class="navbar-nav">
              <li class="nav-item">
                <a class="nav-link active" aria-current="page" href="{%url 'my_app:index'%}">Home</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" href="{%url 'my_app:parent_list'%}">Parents</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" href="{%url 'my_app:parent_create'%}">Parent Create</a>
              </li>

              {%if user.is_authenticated %}
              <li class="nav-item">
                <a class="nav-link" href="{%url 'my_app:logout'%}">Logout</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" href="#">Welcome {{user.username}}</a>
              </li>
              {%else%}
              <li class="nav-item">
                <a class="nav-link" href="{%url 'my_app:login'%}">Login</a>
              </li>
              {%endif%}
              <li class="nav-item">
                <a class="nav-link" href="{%url 'my_app:my_req'%}">req</a>
              </li>
            </ul>
          </div>
        </div>
      </nav>
<div class="jumbotron">
   {%block content%} 
   {%endblock%}
   {% block messages %}
   {%endblock%}
   {% block scripts %}
   {%endblock%}
</div>
</body>
</html>

django/my_try/my_project/my_app/templates/my_app/delete.html
{%extends 'base.html'%}
{%block content%}
<h1>Delete {{object.first_name}}</h1>
<form method="POST">{%csrf_token%}
    <input type="submit" class="btn btn-danger" value="Delete">
</form>
{%endblock%}

django/my_try/my_project/my_app/templates/my_app/index.html
{%extends 'base.html'%}
{%block content%}
<h1>Welcome to my page</h1>
{% if messages %}
<ul class="messages">
    {% for message in messages %}
    <li {% if message.tags %} class="{{ message.tags }}"{% endif %}>{{ message }}</li>
    {% endfor %}
</ul>
{% endif %}
{%endblock%}

django/my_try/my_project/my_app/templates/my_app/login.html
{%extends 'base.html'%}
{%block content%}
    <form method="POST">
        {%csrf_token%}
        {{form.as_p}}
        <button class="btn btn-primary" type="submit">Login</button>
    </form>
    <p>If you don't have an account please <a href="{%url 'my_app:register' %}">register</a>.</p>
    {% if messages %}
    <ul class="messages">
        {% for message in messages %}
        <li {% if message.tags %} class="{{ message.tags }}"{% endif %}>{{ message }}</li>
        {% endfor %}
    </ul>
    {% endif %}
{%endblock%}

django/my_try/my_project/my_app/templates/my_app/my_req.html
{%extends 'base.html'%}
{%block content%}

<style>
    /* form errors and request messages and alerts */
.badge-light {
    margin-top: 2.5em;
}
.errorlist {
    list-style: none;
    padding-left: 0px;
    opacity: 0.8;
    color: #dc3545;
    font-size: 12px;
}
.msg {
    margin: 0 !important;
    margin-bottom: 4px !important;
    margin-top: 4px !important;
}
.messages {
    z-index: 100;
    position: fixed;
    right: 2em;
    margin-top: -1em;
    list-style: none;
    text-align: right;
}
.alert {
    margin-top: 1rem;
}
.alert-error {
    background-color: #f2dede;
    border-color: #ebcccc;
    color: #a94442;
}
</style>
<script>
    document.body.addEventListener( 'click', function (event) {
        if( event.target.className === 'unique_class_name' ) {
            const form = event.target.form;
            const data = new FormData(form);
    
            const request = new XMLHttpRequest();
            request.open(form.method, form.action, true);
            request.send(data);
    
            // logFormData(data);
           
            request.addEventListener("load", function () {
                if (this.readyState === 4 && this.status === 200) {
    
                    // catch JsonResponse from Django
                    const response = JSON.parse(this.responseText);
    
                    // display message
                    const messages = document.getElementById("messages-list");
                    messages.innerHTML += response.msg;
                    fade_alerts();
                }
            });
        }
    
    });

    // logging key-value pairs of FormData object
function logFormData(data) {
    for (const pair of data.entries()) {
        console.log(pair[0] + ": " + pair[1]);
    }
}


// fade out message alerts
function fade_alerts() {
    alerts = document.getElementsByClassName("alert msg");
        var i = alerts.length;
        for (let elem of alerts) {
            i--;
            time = 3250+(1000*i);
            setTimeout(function() {
                $(elem).fadeOut("slow");
            }, time);
        }
}

// call fade out after DOMContentLoaded
window.addEventListener('DOMContentLoaded', (event) => {
    fade_alerts();
});
</script>
    <ul>
        {%for i in form%}
        <li>{{i.name}}</li>
        {%endfor%}
    </ul>
    {% block messages %}
    <ul class="messages" id="messages-list">
    {% if messages %}
        {% for message in messages %}
        <li>
            {% if message.tags %}
                 <div class="alert alert-{{ message.tags }} msg fade show" role="alert">{{ message }}</div>
            {% else %}
                <div class="alert alert-info msg fade show" role="alert">{{ message }}</div>
            {% endif %}
        </li>
        {% endfor %}
    {% endif %}
    </ul>
{% endblock %}

{% block scripts %}
<script src="{% static 'journal/scripts/main.js' %}"></script>
{% endblock %}

{%endblock%}

django/my_try/my_project/my_app/templates/my_app/parent_create.html
{%extends 'base.html'%}
{%block content%}
<form method="POST">{%csrf_token%}
    {{form.as_p}}
    <input type="submit" value="Save" class="btn btn-primary">
</form>
{%if user.is_authenticated%}
<h1>So, you are authenticated</h1>
{%else%}
<h2>So, you are not authenticated</h2>
{%endif%}
{%endblock%}

django/my_try/my_project/my_app/templates/my_app/parent_detail.html
{%extends 'base.html'%}
{%block content%}
<h1>Hello to {{object.first_name}}.</h1>
<input type="submit" class="btn btn-danger" value="Delete">
{%endblock%}

django/my_try/my_project/my_app/templates/my_app/parent_list.html
{%extends 'base.html'%}
{%block content%}
<ul>
    {%if parent_list%}
        {%for parent in parent_list%}
        <li><a href="{%url 'my_app:parent_detail' pk=parent.pk%}">
            Welocome to {{parent.first_name}} {{parent.last_name}} who is {{parent.nationality}}</a></li>
        {%endfor%}
    {%endif%}
</ul>

{%endblock%}

django/my_try/my_project/my_app/templates/my_app/register.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <div class="container">
        <h1>Register</h1>
        <form method="POST">{%csrf_token%}
            {{register_form.as_p}}
            <button class="btn btn-primary" type="submit">Register</button>
        </form>
        <p>If you are already registered, please <a href="{%url 'my_app:login' %}">login</a></p>
    </div>
    {% if messages %}
<ul class="messages">
    {% for message in messages %}
    <li {% if message.tags %} class="{{ message.tags }}"{% endif %}>{{ message }}</li>
    {% endfor %}
</ul>
{% endif %}
</body>
</html>